###############################################################################

PREFIX=V;export PREFIX
VERSION=451; export VERSION
WEBESVER=${VERSION};export WEBESVER
WEBESDOTVER=4.5.1;export WEBESDOTVER
WEBESBUILDLEVEL=;export WEBESBUILDLEVEL
WCCVER=451;export WCCVER
WCCDOTVER=4.5.1;export WCCDOTVER
KNOWN_WEBESVER="${PREFIX}${WEBESDOTVER}";export KNOWN_WEBESVER
WCCPROXYVER=141;export WCCPROXYVER
WCCPROXYDOTVER=1.4.1;export WCCPROXYDOTVER
WCCPROXY_HOME=${INSTDIR}/usr/opt/hp/svctools; export WCCPROXY_HOME
REGISTRY_HOME=${WCCPROXY_HOME}/specific/wccproxy/config; export REGISTRY_HOME
WEBESRPM=4.5-1;export WEBESRPM
WCCPROXYRPM=1.4-1;export WCCPROXYRPM

display_welcome_banner ()
{
  /bin/cat <<EOF

Welcome to the Web-Based Enterprise Service Suite ${PREFIX}${WEBESDOTVER}
Installation Utility.

This wrapper script will do the necessary pre-requisite checks for Webes kit installation. 
Upon successful installation of Webes kit, dependent subset installation and configuration can be done by using the webes_install_update script.

EOF

}

#Note: 
#     If you want to start with a clean error log as of this installation, follow the instructions in the WEBES Installation #Guide,
#     section 3.1 Pre-Installation, in the section "Archiving and cleaning the Error Log". If you do not clean the error log, #the 
#     System Event Analyzer may take a while to process the existing error log after installation.
#
#Warning: 
#        Not clearing the event log before continuing the installation may result in SEA sending notifications for recent #events
#        that have already been serviced. Please compare any notifications received within a few minutes of WEBES #installation 
#        with your service records to avoid duplicate replacements.
# 


remove_existing_proxy()
{       
  #First mv the ref.cnt file. Otherwise it willnot allow
  #to deinstall the older version.
  if [ -f ${WCCPROXY_HOME}/common/wccproxy/ref.cnt ]; then
        FILE=${WCCPROXY_HOME}/common/wccproxy/ref.cnt
        mv $FILE ${WCCPROXY_HOME}
  fi
  rpm -e WEBESPROXY-${PROXY_INSTALLEDRPM}
  rpm -ih WEBESPROXY-${WCCPROXYRPM}.i386.rpm

## The following code is included to handle the WCCProxy Reference Count on WEBES Upgrade
  ISEE_INSTALL_STATUS=`rpm -qa | grep ISEE*`
  if [ -f ${WCCPROXY_HOME}/common/wccproxy/ref.cnt ]; then
        FILE=${WCCPROXY_HOME}/common/wccproxy/ref.cnt
        GR_ITEM=""
        GR_ITEM=`/bin/grep REFERENCE_COUNT $FILE | /bin/cut -f 2 -d=`
        if [ -z "$ISEE_INSTALL_STATUS" ]; then
                GR_ITEM=`expr $GR_ITEM - 1`
        fi
   rm -rf ${WCCPROXY_HOME}/common/wccproxy/ref.cnt
   touch ${WCCPROXY_HOME}/common/wccproxy/ref.cnt
   /bin/cat << EOF >> ${WCCPROXY_HOME}/common/wccproxy/ref.cnt
REFERENCE_COUNT=$GR_ITEM
EOF
   fi

}
 
increment_proxy_count()
 {
   if [ -f ${WCCPROXY_HOME}/common/wccproxy/ref.cnt ]; then
   FILE=${WCCPROXY_HOME}/common/wccproxy/ref.cnt
   GR_ITEM=""
   GR_ITEM=`/bin/grep REFERENCE_COUNT $FILE | /bin/cut -f 2 -d=`
   if [ "$GR_ITEM" -eq "2" -o "$GR_ITEM" -gt "2" ]; then
      GR_ITEM=2
   else
      GR_ITEM=`expr $GR_ITEM + 1`
   fi
   rm -rf ${WCCPROXY_HOME}/common/wccproxy/ref.cnt
   touch ${WCCPROXY_HOME}/common/wccproxy/ref.cnt
   /bin/cat << EOF >> ${WCCPROXY_HOME}/common/wccproxy/ref.cnt
REFERENCE_COUNT=$GR_ITEM
EOF
 fi

 }    
     
exit_if_WEBES_installed ()
{
  
 INSTALLED=""
 INSTALLEDVER=""
 INSTALLEDDOTVER=""

 PKG=`rpm -aq|grep WEBESBASE`

 if [ "$PKG" != "" ]; then

    INSTALLED="true"

    INSTALLEDVER="`echo $PKG 2> /dev/null | /bin/cut -f2,3 -d "-" | cut -c1,3,5`";export INSTALLEDVER
    INSTALLEDDOTVER="`echo $PKG 2> /dev/null | /bin/cut -f2 -d "-"`";export INSTALLEDDOTVER

    if [ -n "${INSTALLED}" ]; then
        if [ "${WCCVER}" -gt "${INSTALLEDVER}" ]; then
         /bin/cat <<EOF

An older version of the Web-Based Enterprise Service Suite (${INSTALLEDVER}) is currently installed.
That version must be deinstalled before this procedure can be executed.

EOF
                exit  1
         fi


         if [ -n  "${INSTALLEDVER}" ]; then

	       /bin/cat <<EOF


A newer version of the Web-Based Enterprise Service Suite (${INSTALLEDVER})
is currently installed. That version must be deinstalled before 
this procedure can be executed.

EOF
        	exit  1

         fi

    fi

else

  verify_webesproxy

  #install webes for the first time

  rpm -ih WEBESBASE-${WEBESRPM}.i386.rpm
fi
}

verify_webesproxy() 
{


 # Now check for any standalone WCCPROXY kits that might have installed
 # by other kits like ISEE.
 #
   PROXY_INSTALLED=""
   PROXY_INSTALLEDVER=""
   PROXY_INSTALLEDDOTVER=""
    
   PROXY_PKG=`rpm -qa|grep WEBESPROXY`

   if [ "$PROXY_PKG" != "" ]; then

   PROXY_INSTALLED="true"

   PROXY_INSTALLEDVER="`echo $PROXY_PKG 2> /dev/null | /bin/cut -f2,3 -d "-" | cut -c1,3,5`"
   PROXY_INSTALLEDDOTVER="`echo $PROXY_PKG 2> /dev/null | /bin/cut -f2 -d "-"`";export PROXY_INSTALLEDDOTVER
   PROXY_INSTALLEDRPM="`echo $PROXY_INSTALLEDVER 2> /dev/null | /bin/sed -n 's/\([0-9]\)\([0-9]\)\([0-9]\)/\1.\2-\3/p'`"


     if [ -n "${PROXY_INSTALLED}" ]; then

      if [ "${PROXY_INSTALLEDVER}" -gt "${WCCPROXYVER}" ]; then
        /bin/cat <<EOF

A newer version of WCCPROXY-${PROXY_INSTALLEDRPM} is currently installed.

Hence no update action  is required.

EOF
        increment_proxy_count
       #exit 1
      elif [ "${PROXY_INSTALLEDVER}" -lt "${WCCPROXYVER}" ]; then
        /bin/cat <<EOF

An older version of the WCCPROXY-${PROXY_INSTALLEDRPM} is currently installed.
This will be uninstalled first and newer version will be installed.

EOF

         remove_existing_proxy
      elif [ -n "${PROXY_INSTALLEDVER}" ]; then
        /bin/cat <<EOF

Same version of the WCCPROXY-${PROXY_INSTALLEDRPM}
is currently found installed. Hence no update action is required.

EOF
        increment_proxy_count
       # exit 1
      fi
   fi
else

 #install wccproxy for the first time
  rpm -ih WEBESPROXY-${WCCPROXYRPM}.i386.rpm
  #increment_proxy_count

fi
}

#############Dec18,2003 The exit_gracefully() is intended only for Dec19,2003 release.
############# This function needs to be deleted after the Dec19,2003

exit_gracefully()
{

   PROXY_INSTALLED_CHECK=""
   WEBES_INSTALLED_CHECK=""

   PROXY_INSTALLED_CHECK=`rpm -qa|grep ^WEBESPROXY`
   WEBES_INSTALLED_CHECK=`rpm -aq|grep ^WEBESBASE`

     if [ "$PROXY_INSTALLED_CHECK" != "" ]; then
         if [  "$WEBES_INSTALLED_CHECK" != "" ]; then
            /bin/echo "                         Upgrade is not supported by WEBESV4.3.2 version "
             exit 1
         elif [ "$WEBES_INSTALLED_CHECK" = "" ]; then
             exit_if_WEBES_installed
         fi
     elif [ "$PROXY_INSTALLED_CHECK" = "" ]; then
           exit_if_WEBES_installed
     fi

}

#############Dec18,2003 The exit_gracefully() is intended only for Dec19,2003 release.
############# This function needs to be deleted after the Dec19,2003

##################### START EXECUTION OF SCRIPT #############################

# the permissions check and include the utilities script.

  WHO=`/usr/bin/whoami`
  WHO=`echo $WHO|cut -f1 -d " "`
  if [ "$WHO" != "root" ]; then
     /bin/echo ""
     /bin/echo "Permission denied. Script may only be executed by root "
     /bin/echo ""
     exit 1
  fi

 display_welcome_banner

# exit_gracefully
 exit_if_WEBES_installed
